
;CodeVisionAVR C Compiler V1.25.5 Professional
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega16
;Program type           : Application
;Clock frequency        : 12.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega16
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "2.vec"
	.INCLUDE "2.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.25.5 Professional
;       4 Automatic Program Generator
;       5  Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 
;       8 Project :
;       9 Version :
;      10 Date    : 7/10/2007
;      11 Author  : F4CG
;      12 Company : F4CG
;      13 Comments:
;      14 
;      15 
;      16 Chip type           : ATmega16
;      17 Program type        : Application
;      18 Clock frequency     : 12.000000 MHz
;      19 Memory model        : Small
;      20 External SRAM size  : 0
;      21 Data Stack size     : 256
;      22 *****************************************************/
;      23 
;      24 #include <mega16.h>
;      25 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      26 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      27 	.EQU __se_bit=0x40
	.EQU __se_bit=0x40
;      28 	.EQU __sm_mask=0xB0
	.EQU __sm_mask=0xB0
;      29 	.EQU __sm_powerdown=0x20
	.EQU __sm_powerdown=0x20
;      30 	.EQU __sm_powersave=0x30
	.EQU __sm_powersave=0x30
;      31 	.EQU __sm_standby=0xA0
	.EQU __sm_standby=0xA0
;      32 	.EQU __sm_ext_standby=0xB0
	.EQU __sm_ext_standby=0xB0
;      33 	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_adc_noise_red=0x10
;      34 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      35 	#endif
	#endif
;      36 #include <stdio.h>
;      37 #include <stdlib.h>
;      38 #include <string.h>
;      39 #include <math.h>
;      40 #include <delay.h>
;      41 
;      42 
;      43 // Alphanumeric LCD Module functions
;      44 #asm
;      45    .equ __lcd_port=0x18 ;PORTB
   .equ __lcd_port=0x18 ;PORTB
;      46 #endasm
;      47 #include <lcd.h>
;      48 
;      49 
;      50 
;      51 
;      52 ////////////////////////////////////////////////////////////
;      53 //                      defines                           //
;      54 ////////////////////////////////////////////////////////////
;      55 
;      56 #define motor_dir_pin0 PORTC.0
;      57 #define motor_dir_pin1 PORTC.1
;      58 
;      59 #define motor_dir_ddr0 DDRC.0
;      60 #define motor_dir_ddr1 DDRC.1
;      61 
;      62 #define right 0
;      63 #define left 1
;      64 
;      65 ////////////////////////////////////////////////////////////
;      66 //                                                        //
;      67 ////////////////////////////////////////////////////////////
;      68 
;      69 char rx_buffer1[8];
_rx_buffer1:
	.BYTE 0x8
;      70 int speed_ctr=0;
;      71 
;      72 char i,str[4];
_str:
	.BYTE 0x4
;      73 int pwm;
;      74 
;      75 char lcd_str[20];
_lcd_str:
	.BYTE 0x14
;      76 unsigned int ctr=0;
;      77 ////////////////////////////////////////////////////////////
;      78 //                    functions                            //
;      79 ////////////////////////////////////////////////////////////
;      80 
;      81 void motor_dir(unsigned char dir);
;      82 void micro_init(void);
;      83 
;      84 
;      85 
;      86 
;      87 ////////////////////////////////////////////////////////////
;      88 //             External Interrupt 0 service routine       //
;      89 ////////////////////////////////////////////////////////////
;      90 
;      91 interrupt [EXT_INT0] void ext_int0_isr(void)
;      92 {

	.CSEG
_ext_int0_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;      93         speed_ctr++;
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
;      94 
;      95 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;      96 
;      97 ////////////////////////////////////////////////////////////
;      98 ////////////////////////////////////////////////////////////
;      99 
;     100 #define RXB8 1
;     101 #define TXB8 0
;     102 #define UPE 2
;     103 #define OVR 3
;     104 #define FE 4
;     105 #define UDRE 5
;     106 #define RXC 7
;     107 
;     108 #define FRAMING_ERROR (1<<FE)
;     109 #define PARITY_ERROR (1<<UPE)
;     110 #define DATA_OVERRUN (1<<OVR)
;     111 #define DATA_REGISTER_EMPTY (1<<UDRE)
;     112 #define RX_COMPLETE (1<<RXC)
;     113 
;     114 // USART Receiver buffer
;     115 #define RX_BUFFER_SIZE 8
;     116 char rx_buffer[RX_BUFFER_SIZE];

	.DSEG
_rx_buffer:
	.BYTE 0x8
;     117 
;     118 #if RX_BUFFER_SIZE<256
;     119 unsigned char rx_wr_index,rx_rd_index,rx_counter;
;     120 #else
;     121 unsigned int rx_wr_index,rx_rd_index,rx_counter;
;     122 #endif
;     123 
;     124 // This flag is set on USART Receiver buffer overflow
;     125 bit rx_buffer_overflow;
;     126 
;     127 
;     128 ////////////////////////////////////////////////////////////
;     129 //       USART Receiver interrupt service routine         //
;     130 ////////////////////////////////////////////////////////////
;     131 
;     132 interrupt [USART_RXC] void usart_rx_isr(void)
;     133 {

	.CSEG
_usart_rx_isr:
	CALL SUBOPT_0x0
;     134 char status,data;
;     135 status=UCSRA;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	IN   R17,11
;     136 data=UDR;
	IN   R16,12
;     137 if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BREQ PC+3
	JMP _0x3
;     138    {
;     139         if (data=='#')
	CPI  R16,35
	BRNE _0x4
;     140         {
;     141                 rx_buffer[0]=data;
	STS  _rx_buffer,R16
;     142                 rx_wr_index=1;
	LDI  R30,LOW(1)
	MOV  R6,R30
;     143         }
;     144         else if (rx_wr_index==1 && data=='!')
	RJMP _0x5
_0x4:
	LDI  R30,LOW(1)
	CP   R30,R6
	BRNE _0x7
	CPI  R16,33
	BREQ _0x8
_0x7:
	RJMP _0x6
_0x8:
;     145         {
;     146 
;     147                 /////////////////////////
;     148         }
;     149         else if (rx_wr_index>=1 && rx_wr_index<=5)
	RJMP _0x9
_0x6:
	LDI  R30,LOW(1)
	CP   R6,R30
	BRLO _0xB
	LDI  R30,LOW(5)
	CP   R30,R6
	BRSH _0xC
_0xB:
	RJMP _0xA
_0xC:
;     150         {
;     151                 rx_buffer[rx_wr_index]=data;
	MOV  R30,R6
	LDI  R31,0
	SUBI R30,LOW(-_rx_buffer)
	SBCI R31,HIGH(-_rx_buffer)
	ST   Z,R16
;     152                 rx_wr_index++;
	INC  R6
;     153                 if (rx_wr_index==5)
	LDI  R30,LOW(5)
	CP   R30,R6
	BRNE _0xD
;     154                 {
;     155 
;     156                         strcpy(rx_buffer1,rx_buffer);
	LDI  R30,LOW(_rx_buffer1)
	LDI  R31,HIGH(_rx_buffer1)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_rx_buffer)
	LDI  R31,HIGH(_rx_buffer)
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpy
;     157                         for (i=0;i<4;i++)
	CLR  R7
_0xF:
	LDI  R30,LOW(4)
	CP   R7,R30
	BRSH _0x10
;     158                         {
;     159                                 #pragma warn-
;     160                                 str[i]=rx_buffer1[i+1];
	MOV  R26,R7
	LDI  R27,0
	SUBI R26,LOW(-_str)
	SBCI R27,HIGH(-_str)
	MOV  R30,R7
	LDI  R31,0
	__ADDW1MN _rx_buffer1,1
	LD   R30,Z
	ST   X,R30
;     161                                 #pragma warn+
;     162                         }
	INC  R7
	RJMP _0xF
_0x10:
;     163                         pwm=atoi(str);
	LDI  R30,LOW(_str)
	LDI  R31,HIGH(_str)
	ST   -Y,R31
	ST   -Y,R30
	CALL _atoi
	MOVW R8,R30
;     164                         OCR2=abs(pwm);
	ST   -Y,R9
	ST   -Y,R8
	CALL _abs
	OUT  0x23,R30
;     165                 }
;     166         }else
_0xD:
	RJMP _0x11
_0xA:
;     167                 rx_wr_index=0;
	CLR  R6
;     168 
;     169         if (++rx_counter == RX_BUFFER_SIZE)
_0x11:
_0x9:
_0x5:
	INC  R12
	LDI  R30,LOW(8)
	CP   R30,R12
	BRNE _0x12
;     170         {
;     171                 rx_counter=0;
	CLR  R12
;     172                 rx_buffer_overflow=1;
	SET
	BLD  R2,0
;     173         };
_0x12:
;     174    };
_0x3:
;     175 }
	LD   R16,Y+
	LD   R17,Y+
	RJMP _0xDA
;     176 
;     177 ////////////////////////////////////////////////////////////
;     178 ////////////////////////////////////////////////////////////
;     179 
;     180 #ifndef _DEBUG_TERMINAL_IO_
;     181 // Get a character from the USART Receiver buffer
;     182 #define _ALTERNATE_GETCHAR_
;     183 #pragma used+
;     184 char getchar(void)
;     185 {
;     186 char data;
;     187 while (rx_counter==0);
;	data -> R17
;     188 data=rx_buffer[rx_rd_index];
;     189 if (++rx_rd_index == RX_BUFFER_SIZE) rx_rd_index=0;
;     190 #asm("cli")
;     191 --rx_counter;
;     192 #asm("sei")
;     193 return data;
;     194 }
;     195 #pragma used-
;     196 #endif
;     197 
;     198 
;     199 ////////////////////////////////////////////////////////////
;     200 //       Timer 1 overflow interrupt service routine       //
;     201 ////////////////////////////////////////////////////////////
;     202 interrupt [TIM1_OVF] void timer1_ovf_isr(void)
;     203 {
_timer1_ovf_isr:
	CALL SUBOPT_0x0
;     204         ctr++;
	MOVW R30,R10
	ADIW R30,1
	MOVW R10,R30
	SBIW R30,1
;     205         if(ctr==4)
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	CP   R30,R10
	CPC  R31,R11
	BRNE _0x17
;     206         {
;     207                 ctr=0;
	CLR  R10
	CLR  R11
;     208                 printf("%d\r",speed_ctr);
	__POINTW1FN _0,0
	CALL SUBOPT_0x1
	CALL _printf
	ADIW R28,6
;     209 
;     210                 speed_ctr=0;
	CLR  R4
	CLR  R5
;     211 
;     212         }
;     213 
;     214         TCNT1=28036;
_0x17:
	LDI  R30,LOW(28036)
	LDI  R31,HIGH(28036)
	OUT  0x2C+1,R31
	OUT  0x2C,R30
;     215 
;     216 
;     217 }
_0xDA:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     218 
;     219 
;     220 
;     221 ////////////////////////////////////////////////////////////
;     222 //                       main                             //
;     223 ////////////////////////////////////////////////////////////
;     224 
;     225 void main(void)
;     226 {
_main:
;     227 
;     228 
;     229 micro_init();
	RCALL _micro_init
;     230 motor_dir_ddr0=1;
	SBI  0x14,0
;     231 motor_dir_ddr1=1;
	SBI  0x14,1
;     232 motor_dir(right);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _motor_dir
;     233 
;     234 PORTC=0b00000101;
	LDI  R30,LOW(5)
	OUT  0x15,R30
;     235 
;     236 
;     237 printf("\r\n START \r");
	__POINTW1FN _0,4
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     238 
;     239 while (1)
_0x18:
;     240       {
;     241 
;     242 
;     243 
;     244                 lcd_clear();
	CALL _lcd_clear
;     245                 lcd_gotoxy(0,0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	CALL _lcd_gotoxy
;     246                 sprintf(lcd_str,"SPEED=%d RPS",speed_ctr);
	LDI  R30,LOW(_lcd_str)
	LDI  R31,HIGH(_lcd_str)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,15
	CALL SUBOPT_0x1
	CALL _sprintf
	ADIW R28,8
;     247                 lcd_puts(lcd_str);
	LDI  R30,LOW(_lcd_str)
	LDI  R31,HIGH(_lcd_str)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_puts
;     248                 lcd_gotoxy(0,1);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_gotoxy
;     249                 lcd_putsf("**DC MOTOR**");
	__POINTW1FN _0,28
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
;     250 
;     251 
;     252       };
	RJMP _0x18
;     253 }
_0x1B:
	RJMP _0x1B
;     254 
;     255 ////////////////////////////////////////////////////////////
;     256 //                       motor_dir                        //
;     257 ////////////////////////////////////////////////////////////
;     258 
;     259 void motor_dir(unsigned char dir)
;     260 {
_motor_dir:
;     261         if(dir==0)
;	dir -> Y+0
	LD   R30,Y
	CPI  R30,0
	BRNE _0x1C
;     262         {
;     263                 motor_dir_pin0=0;
	CBI  0x15,0
;     264                 motor_dir_pin1=1;
	SBI  0x15,1
;     265 
;     266         }
;     267         else if(dir==1)
	RJMP _0x1D
_0x1C:
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0x1E
;     268         {
;     269                 motor_dir_pin0=1;
	SBI  0x15,0
;     270                 motor_dir_pin1=0;
	CBI  0x15,1
;     271 
;     272         }
;     273 }
_0x1E:
_0x1D:
	ADIW R28,1
	RET
;     274 
;     275 ////////////////////////////////////////////////////////////
;     276 //                       micro_init                       //
;     277 ////////////////////////////////////////////////////////////
;     278 
;     279 void micro_init(void)
;     280 {
_micro_init:
;     281 
;     282 // Input/Output Ports initialization
;     283 // Port A initialization
;     284 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     285 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     286 PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;     287 DDRA=0x00;
	OUT  0x1A,R30
;     288 
;     289 // Port B initialization
;     290 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     291 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     292 PORTB=0x00;
	OUT  0x18,R30
;     293 DDRB=0x00;
	OUT  0x17,R30
;     294 
;     295 // Port C initialization
;     296 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     297 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     298 PORTC=0x00;
	OUT  0x15,R30
;     299 DDRC=0x00;
	OUT  0x14,R30
;     300 
;     301 // Port D initialization
;     302 // Func7=Out Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     303 // State7=0 State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     304 PORTD=0x00;
	OUT  0x12,R30
;     305 DDRD=0x80;
	LDI  R30,LOW(128)
	OUT  0x11,R30
;     306 
;     307 // Timer/Counter 0 initialization
;     308 // Clock source: System Clock
;     309 // Clock value: Timer 0 Stopped
;     310 // Mode: Normal top=FFh
;     311 // OC0 output: Disconnected
;     312 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
;     313 TCNT0=0x00;
	OUT  0x32,R30
;     314 OCR0=0x00;
	OUT  0x3C,R30
;     315 
;     316 // Timer/Counter 1 initialization
;     317 // Clock source: System Clock
;     318 // Clock value: 187.500 kHz
;     319 // Mode: Normal top=FFFFh
;     320 // OC1A output: Discon.
;     321 // OC1B output: Discon.
;     322 // Noise Canceler: Off
;     323 // Input Capture on Falling Edge
;     324 // Timer 1 Overflow Interrupt: On
;     325 // Input Capture Interrupt: Off
;     326 // Compare A Match Interrupt: Off
;     327 // Compare B Match Interrupt: Off
;     328 TCCR1A=0x00;
	OUT  0x2F,R30
;     329 TCCR1B=0x03;
	LDI  R30,LOW(3)
	OUT  0x2E,R30
;     330 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;     331 TCNT1L=0x00;
	OUT  0x2C,R30
;     332 ICR1H=0x00;
	OUT  0x27,R30
;     333 ICR1L=0x00;
	OUT  0x26,R30
;     334 OCR1AH=0x00;
	OUT  0x2B,R30
;     335 OCR1AL=0x00;
	OUT  0x2A,R30
;     336 OCR1BH=0x00;
	OUT  0x29,R30
;     337 OCR1BL=0x00;
	OUT  0x28,R30
;     338 
;     339 // Timer/Counter 2 initialization
;     340 // Clock source: System Clock
;     341 // Clock value: 11.719 kHz
;     342 // Mode: Fast PWM top=FFh
;     343 // OC2 output: Non-Inverted PWM
;     344 ASSR=0x00;
	OUT  0x22,R30
;     345 TCCR2=0x6F;
	LDI  R30,LOW(111)
	OUT  0x25,R30
;     346 TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
;     347 OCR2=0x00;
	OUT  0x23,R30
;     348 
;     349 // External Interrupt(s) initialization
;     350 // INT0: On
;     351 // INT0 Mode: Falling Edge
;     352 // INT1: Off
;     353 // INT2: Off
;     354 GICR|=0x40;
	IN   R30,0x3B
	ORI  R30,0x40
	OUT  0x3B,R30
;     355 MCUCR=0x02;
	LDI  R30,LOW(2)
	OUT  0x35,R30
;     356 MCUCSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x34,R30
;     357 GIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
;     358 
;     359 // Timer(s)/Counter(s) Interrupt(s) initialization
;     360 TIMSK=0x04;
	LDI  R30,LOW(4)
	OUT  0x39,R30
;     361 
;     362 // USART initialization
;     363 // Communication Parameters: 8 Data, 1 Stop, No Parity
;     364 // USART Receiver: On
;     365 // USART Transmitter: On
;     366 // USART Mode: Asynchronous
;     367 // USART Baud rate: 9600
;     368 UCSRA=0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
;     369 UCSRB=0x98;
	LDI  R30,LOW(152)
	OUT  0xA,R30
;     370 UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
;     371 UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
;     372 UBRRL=0x4D;
	LDI  R30,LOW(77)
	OUT  0x9,R30
;     373 
;     374 // Analog Comparator initialization
;     375 // Analog Comparator: Off
;     376 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     377 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     378 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     379 
;     380 // LCD module initialization
;     381 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _lcd_init
;     382 
;     383 // Global enable interrupts
;     384 #asm("sei")
	sei
;     385 
;     386 }
	RET

	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x1F
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x21
	__CPWRN 16,17,2
	BRLO _0x22
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0x21:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0x22:
	RJMP _0x23
_0x1F:
	LDD  R30,Y+6
	ST   -Y,R30
	CALL _putchar
_0x23:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,7
	RET
__print_G2:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
_0x24:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x26
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x2A
	CPI  R18,37
	BRNE _0x2B
	LDI  R17,LOW(1)
	RJMP _0x2C
_0x2B:
	CALL SUBOPT_0x2
_0x2C:
	RJMP _0x29
_0x2A:
	CPI  R30,LOW(0x1)
	BRNE _0x2D
	CPI  R18,37
	BRNE _0x2E
	CALL SUBOPT_0x2
	RJMP _0xD7
_0x2E:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2F
	LDI  R16,LOW(1)
	RJMP _0x29
_0x2F:
	CPI  R18,43
	BRNE _0x30
	LDI  R20,LOW(43)
	RJMP _0x29
_0x30:
	CPI  R18,32
	BRNE _0x31
	LDI  R20,LOW(32)
	RJMP _0x29
_0x31:
	RJMP _0x32
_0x2D:
	CPI  R30,LOW(0x2)
	BRNE _0x33
_0x32:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x34
	ORI  R16,LOW(128)
	RJMP _0x29
_0x34:
	RJMP _0x35
_0x33:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x29
_0x35:
	CPI  R18,48
	BRLO _0x38
	CPI  R18,58
	BRLO _0x39
_0x38:
	RJMP _0x37
_0x39:
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x29
_0x37:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x3D
	CALL SUBOPT_0x3
	LD   R30,X
	CALL SUBOPT_0x4
	RJMP _0x3E
_0x3D:
	CPI  R30,LOW(0x73)
	BRNE _0x40
	CALL SUBOPT_0x3
	CALL SUBOPT_0x5
	CALL _strlen
	MOV  R17,R30
	RJMP _0x41
_0x40:
	CPI  R30,LOW(0x70)
	BRNE _0x43
	CALL SUBOPT_0x3
	CALL SUBOPT_0x5
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x41:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x44
_0x43:
	CPI  R30,LOW(0x64)
	BREQ _0x47
	CPI  R30,LOW(0x69)
	BRNE _0x48
_0x47:
	ORI  R16,LOW(4)
	RJMP _0x49
_0x48:
	CPI  R30,LOW(0x75)
	BRNE _0x4A
_0x49:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x4B
_0x4A:
	CPI  R30,LOW(0x58)
	BRNE _0x4D
	ORI  R16,LOW(8)
	RJMP _0x4E
_0x4D:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x7F
_0x4E:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x4B:
	SBRS R16,2
	RJMP _0x50
	CALL SUBOPT_0x3
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x51
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x51:
	CPI  R20,0
	BREQ _0x52
	SUBI R17,-LOW(1)
	RJMP _0x53
_0x52:
	ANDI R16,LOW(251)
_0x53:
	RJMP _0x54
_0x50:
	CALL SUBOPT_0x3
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x54:
_0x44:
	SBRC R16,0
	RJMP _0x55
_0x56:
	CP   R17,R21
	BRSH _0x58
	SBRS R16,7
	RJMP _0x59
	SBRS R16,2
	RJMP _0x5A
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x5B
_0x5A:
	LDI  R18,LOW(48)
_0x5B:
	RJMP _0x5C
_0x59:
	LDI  R18,LOW(32)
_0x5C:
	CALL SUBOPT_0x2
	SUBI R21,LOW(1)
	RJMP _0x56
_0x58:
_0x55:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x5D
_0x5E:
	CPI  R19,0
	BREQ _0x60
	SBRS R16,3
	RJMP _0x61
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0xD8
_0x61:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0xD8:
	ST   -Y,R30
	CALL SUBOPT_0x6
	CPI  R21,0
	BREQ _0x63
	SUBI R21,LOW(1)
_0x63:
	SUBI R19,LOW(1)
	RJMP _0x5E
_0x60:
	RJMP _0x64
_0x5D:
_0x66:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
_0x68:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x6A
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x68
_0x6A:
	CPI  R18,58
	BRLO _0x6B
	SBRS R16,3
	RJMP _0x6C
	SUBI R18,-LOW(7)
	RJMP _0x6D
_0x6C:
	SUBI R18,-LOW(39)
_0x6D:
_0x6B:
	SBRC R16,4
	RJMP _0x6F
	CPI  R18,49
	BRSH _0x71
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x70
_0x71:
	RJMP _0xD9
_0x70:
	CP   R21,R19
	BRLO _0x75
	SBRS R16,0
	RJMP _0x76
_0x75:
	RJMP _0x74
_0x76:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x77
	LDI  R18,LOW(48)
_0xD9:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x78
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0x6
	CPI  R21,0
	BREQ _0x79
	SUBI R21,LOW(1)
_0x79:
_0x78:
_0x77:
_0x6F:
	CALL SUBOPT_0x2
	CPI  R21,0
	BREQ _0x7A
	SUBI R21,LOW(1)
_0x7A:
_0x74:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x67
	RJMP _0x66
_0x67:
_0x64:
	SBRS R16,0
	RJMP _0x7B
_0x7C:
	CPI  R21,0
	BREQ _0x7E
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	CALL SUBOPT_0x4
	RJMP _0x7C
_0x7E:
_0x7B:
_0x7F:
_0x3E:
_0xD7:
	LDI  R17,LOW(0)
_0x29:
	RJMP _0x24
_0x26:
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	CALL SUBOPT_0x7
	MOVW R26,R28
	ADIW R26,6
	CALL SUBOPT_0x8
	STD  Y+2,R30
	STD  Y+2+1,R31
	MOVW R26,R28
	ADIW R26,4
	CALL SUBOPT_0x8
	CALL SUBOPT_0x9
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	RJMP _0xD6
_printf:
	PUSH R15
	CALL SUBOPT_0x7
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
	MOVW R26,R28
	ADIW R26,4
	CALL SUBOPT_0x8
	CALL SUBOPT_0x9
_0xD6:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	POP  R15
	RET
_atoi:
   	ldd  r27,y+1
   	ld   r26,y
__atoi0:
   	ld   r30,x
	ST   -Y,R30
	CALL _isspace
   	tst  r30
   	breq __atoi1
   	adiw r26,1
   	rjmp __atoi0
__atoi1:
   	clt
   	ld   r30,x
   	cpi  r30,'-'
   	brne __atoi2
   	set
   	rjmp __atoi3
__atoi2:
   	cpi  r30,'+'
   	brne __atoi4
__atoi3:
   	adiw r26,1
__atoi4:
   	clr  r22
   	clr  r23
__atoi5:
   	ld   r30,x
	ST   -Y,R30
	CALL _isdigit
   	tst  r30
   	breq __atoi6
   	mov  r30,r22
   	mov  r31,r23
   	lsl  r22
   	rol  r23
   	lsl  r22
   	rol  r23
   	add  r22,r30
   	adc  r23,r31
   	lsl  r22
   	rol  r23
   	ld   r30,x+
   	clr  r31
   	subi r30,'0'
   	add  r22,r30
   	adc  r23,r31
   	rjmp __atoi5
__atoi6:
   	mov  r30,r22
   	mov  r31,r23
   	brtc __atoi7
   	com  r30
   	com  r31
   	adiw r30,1
__atoi7:
   	adiw r28,2
   	ret
_abs:
    ld   r30,y+
    ld   r31,y+
    sbiw r30,0
    brpl __abs0
    com  r30
    com  r31
    adiw r30,1
__abs0:
    ret
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G6:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
__lcd_delay_G6:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	CALL __lcd_delay_G6
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G6
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G6
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G6
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G6:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G6
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G6
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output    
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	CALL __lcd_write_nibble_G6
    ld    r26,y
    swap  r26
	CALL __lcd_write_nibble_G6
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
__lcd_read_nibble_G6:
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G6
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G6
    andi  r30,0xf0
	RET
_lcd_read_byte0_G6:
	CALL __lcd_delay_G6
	CALL __lcd_read_nibble_G6
    mov   r26,r30
	CALL __lcd_read_nibble_G6
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	CALL __lcd_ready
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G6)
	SBCI R31,HIGH(-__base_y_G6)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	CALL __lcd_write_data
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
_lcd_clear:
	CALL __lcd_ready
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __lcd_ready
	LDI  R30,LOW(12)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __lcd_ready
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL __lcd_write_data
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R30,R26
	BRSH _0xCC
	__lcd_putchar1:
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R30,__lcd_y
	ST   -Y,R30
	CALL _lcd_gotoxy
	brts __lcd_putchar0
_0xCC:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
	ST   -Y,R17
_0xCD:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0xCF
	ST   -Y,R17
	CALL _lcd_putchar
	RJMP _0xCD
_0xCF:
	LDD  R17,Y+0
	RJMP _0xD5
_lcd_putsf:
	ST   -Y,R17
_0xD0:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0xD2
	ST   -Y,R17
	CALL _lcd_putchar
	RJMP _0xD0
_0xD2:
	LDD  R17,Y+0
_0xD5:
	ADIW R28,3
	RET
__long_delay_G6:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G6:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	CALL __lcd_write_nibble_G6
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G6,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G6,3
	CALL SUBOPT_0xA
	CALL SUBOPT_0xA
	CALL SUBOPT_0xA
	CALL __long_delay_G6
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL __lcd_init_write_G6
	CALL __long_delay_G6
	LDI  R30,LOW(40)
	CALL SUBOPT_0xB
	LDI  R30,LOW(4)
	CALL SUBOPT_0xB
	LDI  R30,LOW(133)
	CALL SUBOPT_0xB
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	CALL _lcd_read_byte0_G6
	CPI  R30,LOW(0x5)
	BREQ _0xD3
	LDI  R30,LOW(0)
	RJMP _0xD4
_0xD3:
	CALL __lcd_ready
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL _lcd_clear
	LDI  R30,LOW(1)
_0xD4:
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x0:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1:
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R4
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R24,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x2:
	ST   -Y,R18
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x3:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	SBIW R26,4
	STD  Y+16,R26
	STD  Y+16+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x4:
	ST   -Y,R30
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5:
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x6:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x7:
	MOV  R15,R24
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	MOVW R16,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	CALL __ADDW2R15
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x9:
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	JMP  __print_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xA:
	CALL __long_delay_G6
	LDI  R30,LOW(48)
	ST   -Y,R30
	JMP  __lcd_init_write_G6

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xB:
	ST   -Y,R30
	CALL __lcd_write_data
	JMP  __long_delay_G6

_isdigit:
	ldi  r30,1
	ld   r31,y+
	cpi  r31,'0'
	brlo __isdigit0
	cpi  r31,'9'+1
	brlo __isdigit1
__isdigit0:
	clr  r30
__isdigit1:
	ret

_isspace:
	ldi  r30,1
	ld   r31,y+
	cpi  r31,' '
	breq __isspace1
	cpi  r31,9
	brlo __isspace0
	cpi  r31,14
	brlo __isspace1
__isspace0:
	clr  r30
__isspace1:
	ret

_isxdigit:
	ldi  r30,1
	ld   r31,y+
	subi r31,0x30
	brcs __isxdigit0
	cpi  r31,10
	brcs __isxdigit1
	andi r31,0x5f
	subi r31,7
	cpi  r31,10
	brcs __isxdigit0
	cpi  r31,16
	brcs __isxdigit1
__isxdigit0:
	clr  r30
__isxdigit1:
	ret

_strcpy:
	ld   r30,y+
	ld   r31,y+
	ld   r26,y+
	ld   r27,y+
	movw r24,r26
__strcpy0:
	ld   r22,z+
	st   x+,r22
	tst  r22
	brne __strcpy0
	movw r30,r24
	ret

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
