/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.5 Professional
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project :
Version :
Date    : 7/10/2007
Author  : F4CG
Company : F4CG
Comments:


Chip type           : ATmega16
Program type        : Application
Clock frequency     : 12.000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega16.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <delay.h>


// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x18 ;PORTB
#endasm
#include <lcd.h>




////////////////////////////////////////////////////////////
//                      defines                           //
////////////////////////////////////////////////////////////

#define motor_dir_pin0 PORTC.0
#define motor_dir_pin1 PORTC.1

#define motor_dir_ddr0 DDRC.0
#define motor_dir_ddr1 DDRC.1

#define right 0
#define left 1

////////////////////////////////////////////////////////////
//                                                        //
////////////////////////////////////////////////////////////

char rx_buffer1[8];
int speed_ctr=0;

char i,str[4];
int pwm;

char lcd_str[20];
unsigned int ctr=0;
////////////////////////////////////////////////////////////
//                    functions                            //
////////////////////////////////////////////////////////////

void motor_dir(unsigned char dir);
void micro_init(void);




////////////////////////////////////////////////////////////
//             External Interrupt 0 service routine       //
////////////////////////////////////////////////////////////

interrupt [EXT_INT0] void ext_int0_isr(void)
{
        speed_ctr++;

}

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////

#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

// USART Receiver buffer
#define RX_BUFFER_SIZE 8
char rx_buffer[RX_BUFFER_SIZE];

#if RX_BUFFER_SIZE<256
unsigned char rx_wr_index,rx_rd_index,rx_counter;
#else
unsigned int rx_wr_index,rx_rd_index,rx_counter;
#endif

// This flag is set on USART Receiver buffer overflow
bit rx_buffer_overflow;


////////////////////////////////////////////////////////////
//       USART Receiver interrupt service routine         //
////////////////////////////////////////////////////////////

interrupt [USART_RXC] void usart_rx_isr(void)
{
char status,data;
status=UCSRA;
data=UDR;
if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
   {
        if (data=='#')
        {
                rx_buffer[0]=data;
                rx_wr_index=1;
        }
        else if (rx_wr_index==1 && data=='!')
        {

                /////////////////////////
        }
        else if (rx_wr_index>=1 && rx_wr_index<=5)
        {
                rx_buffer[rx_wr_index]=data;
                rx_wr_index++;
                if (rx_wr_index==5)
                {

                        strcpy(rx_buffer1,rx_buffer);
                        for (i=0;i<4;i++)
                        {
                                #pragma warn-
                                str[i]=rx_buffer1[i+1];
                                #pragma warn+
                        }
                        pwm=atoi(str);
                        OCR2=abs(pwm);
                }
        }else
                rx_wr_index=0;

        if (++rx_counter == RX_BUFFER_SIZE)
        {
                rx_counter=0;
                rx_buffer_overflow=1;
        };
   };
}

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////

#ifndef _DEBUG_TERMINAL_IO_
// Get a character from the USART Receiver buffer
#define _ALTERNATE_GETCHAR_
#pragma used+
char getchar(void)
{
char data;
while (rx_counter==0);
data=rx_buffer[rx_rd_index];
if (++rx_rd_index == RX_BUFFER_SIZE) rx_rd_index=0;
#asm("cli")
--rx_counter;
#asm("sei")
return data;
}
#pragma used-
#endif


////////////////////////////////////////////////////////////
//       Timer 1 overflow interrupt service routine       //
////////////////////////////////////////////////////////////
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
        ctr++;
        if(ctr==4)
        {
                ctr=0;
                printf("%d\r",speed_ctr);

                speed_ctr=0;

        }

        TCNT1=28036;


}



////////////////////////////////////////////////////////////
//                       main                             //
////////////////////////////////////////////////////////////

void main(void)
{


micro_init();
motor_dir_ddr0=1;
motor_dir_ddr1=1;
motor_dir(right);

PORTC=0b00000101;


printf("\r\n START \r");

while (1)
      {



                lcd_clear();
                lcd_gotoxy(0,0);
                sprintf(lcd_str,"SPEED=%d RPS",speed_ctr);
                lcd_puts(lcd_str);
                lcd_gotoxy(0,1);
                lcd_putsf("**DC MOTOR**");


      };
}

////////////////////////////////////////////////////////////
//                       motor_dir                        //
////////////////////////////////////////////////////////////

void motor_dir(unsigned char dir)
{
        if(dir==0)
        {
                motor_dir_pin0=0;
                motor_dir_pin1=1;

        }
        else if(dir==1)
        {
                motor_dir_pin0=1;
                motor_dir_pin1=0;

        }
}

////////////////////////////////////////////////////////////
//                       micro_init                       //
////////////////////////////////////////////////////////////

void micro_init(void)
{

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=Out Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=0 State6=T State5=T State4=T State3=T State2=T State1=T State0=T
PORTD=0x00;
DDRD=0x80;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 187.500 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x03;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 11.719 kHz
// Mode: Fast PWM top=FFh
// OC2 output: Non-Inverted PWM
ASSR=0x00;
TCCR2=0x6F;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Falling Edge
// INT1: Off
// INT2: Off
GICR|=0x40;
MCUCR=0x02;
MCUCSR=0x00;
GIFR=0x40;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x04;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud rate: 9600
UCSRA=0x00;
UCSRB=0x98;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x4D;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// LCD module initialization
lcd_init(16);

// Global enable interrupts
#asm("sei")

}
